#include "ParamQualifiers.hpp"

namespace core {

abstraction::ParamQualifiers::ParamQualifierSet xmlApi < abstraction::ParamQualifiers::ParamQualifierSet >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );

	abstraction::ParamQualifiers::ParamQualifierSet res = abstraction::ParamQualifiers::ParamQualifierSet::NONE;

	while ( sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::START_ELEMENT, "entry" ) ) {
		sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, "entry" );

		std::string data = sax::FromXMLParserHelper::popTokenData(input, sax::Token::TokenType::CHARACTER);
		if ( data == "lref" )
			res = res | abstraction::ParamQualifiers::ParamQualifierSet::LREF;
		else if ( data == "rref" )
			res = res | abstraction::ParamQualifiers::ParamQualifierSet::RREF;
		else if ( data == "const" )
			res = res | abstraction::ParamQualifiers::ParamQualifierSet::CONST;
		else
			throw exception::CommonException ( "Invalid param qualifier." );

		sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, "entry" );
	}
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );

	return res;
}

bool xmlApi < abstraction::ParamQualifiers::ParamQualifierSet >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken(input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

std::string xmlApi < abstraction::ParamQualifiers::ParamQualifierSet >::xmlTagName ( ) {
	return "ParamQualifierSet";
}

void xmlApi < abstraction::ParamQualifiers::ParamQualifierSet >::compose ( ext::deque < sax::Token > & output, abstraction::ParamQualifiers::ParamQualifierSet paramQualifierSet ) {
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT);
	if ( paramQualifierSet && abstraction::ParamQualifiers::ParamQualifierSet::CONST ) {
		output.emplace_back ( "entry", sax::Token::TokenType::START_ELEMENT);
		output.emplace_back("const", sax::Token::TokenType::CHARACTER);
		output.emplace_back ( "entry", sax::Token::TokenType::END_ELEMENT);
	}
	if ( paramQualifierSet && abstraction::ParamQualifiers::ParamQualifierSet::LREF ) {
		output.emplace_back ( "entry", sax::Token::TokenType::START_ELEMENT);
		output.emplace_back("lref", sax::Token::TokenType::CHARACTER);
		output.emplace_back ( "entry", sax::Token::TokenType::END_ELEMENT);
	}
	if ( paramQualifierSet && abstraction::ParamQualifiers::ParamQualifierSet::RREF ) {
		output.emplace_back ( "entry", sax::Token::TokenType::START_ELEMENT);
		output.emplace_back("rref", sax::Token::TokenType::CHARACTER);
		output.emplace_back ( "entry", sax::Token::TokenType::END_ELEMENT);
	}
	output.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT);
}

} /* namespace core */
